using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using PlayerCoreEngine;

public class PlayerRayCastScript : MonoBehaviour
{
	private float m_fDownRayLength;	
	private Ray m_rDownRay;
	private RaycastHit m_rhGroundHit;
	
	public bool m_bPlayerDead;
	
	public States playerState;
	
	private LevelStates levelstate;
	
	private float m_fDeadZoneWaitTime;
	
	private float m_fMaxDeadZoneWaitTime = 6.0f;
	
	void Awake()
	{
		playerState = new States ();
		levelstate = new LevelStates ();
		
		m_fDeadZoneWaitTime = m_fMaxDeadZoneWaitTime;
	}
	
	void Start()
	{
		m_fDownRayLength = 0.15f;
		playerState.PlayerCurrentState = States.PlayerStates.Live;
	}
	
	void FixedUpdate()
	{
		
		if (levelstate.CurrentLevel != LevelStates.eLevelStates.TurningDown
			|| levelstate.CurrentLevel != LevelStates.eLevelStates.TurningUp)
		{
			RayCastControl();
		}
	/**
		else if (playerState.PlayerCurrentState == States.PlayerStates.Die)
		{
			Application.LoadLevel(0);	
		}
		**/
		
	}
	
	public void RayCastControl()
	{
		Vector3 m_vDown = transform.TransformDirection(Vector3.down);
		m_rDownRay.origin = new Vector3 (transform.position.x, transform.position.y,transform.position.z);
		
		m_rDownRay.direction = m_vDown;
		
		Debug.DrawRay(m_rDownRay.origin, m_rDownRay.direction * m_fDownRayLength, Color.green);
		
		if (Physics.Raycast (m_rDownRay,out m_rhGroundHit, m_fDownRayLength))
		{
			//Debug.Log (m_rhGroundHit.transform.tag);
			
			if (m_rhGroundHit.transform.tag == "DeadZones")
			{
				//m_bPlayerDead = true;
				//playerState.PlayerCurrentState = States.PlayerStates.TouchedDeadZone;
				//StartCoroutine (waitTime(6.0f));
				
				m_fDeadZoneWaitTime -= Time.deltaTime;
			
					if (m_fDeadZoneWaitTime < 0)
					{
						playerState.PlayerCurrentState = States.PlayerStates.Die;
						m_fDeadZoneWaitTime = m_fMaxDeadZoneWaitTime;
						Debug.Log ("dead zone");
						
					}
				
				
			}
			else if(m_rhGroundHit.transform.tag == "Path")
			{
				m_fDeadZoneWaitTime = m_fMaxDeadZoneWaitTime;	
			}
			
		}
		
	}
	
	IEnumerator waitTime(float t)
	{
		yield return new WaitForSeconds(t);
		
		playerState.PlayerCurrentState = States.PlayerStates.Die;
		//Application.LoadLevel(0);
	}
	
	
}